<ng-container [ngSwitch]="type">

    <div 
    *ngSwitchCase="'select'"
    class="input-container"
    [class.error]="(ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid">
        <label>{{label}}<span class="red" *ngIf="required"> *</span></label>
        <select 
        #element
        [(ngModel)]="value"
        (change)="handleChange($event)"
        (focus)="onfocus.emit()"
        (blur)="onTouchedCallback()">
            <option [value]="" disabled selected>Seleccione...</option>
            <option 
            *ngFor="let o of options" 
            [value]="optionsKey ? o[optionsKey] : o">
            {{optionsName ? o[optionsName] : o}}</option>
        </select>
    </div>

    <div
    *ngSwitchCase="'checkbox'"
    class="input-container checkbox"
    [class.error]="(ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid">
        <label>
            <input type="checkbox" [(ngValue)]="value">
            <span></span>
            {{label}}
        </label>
    </div>

    <div 
    *ngSwitchCase="'textarea'"
    class="input-container"
    [class.error]="(ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid">
        <label>{{label}}<span class="red" *ngIf="required"> *</span></label>
        <textarea 
        #element
        [(ngModel)]="value"
        (keyup)="handleChange($event)"
        (focus)="onfocus.emit()"
        (blur)="onTouchedCallback()"></textarea>
    </div>

    <div 
    *ngSwitchDefault
    class="input-container"
    [class.login]="loginStyle"
    [class.disabled]="readonly"
    [class.error]="(ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid">
        <label>{{label}}<span class="red" *ngIf="required"> *</span></label>
        <input 
        #element 
        [type]="type" 
        [(ngModel)]="value"
        (keyup)="handleChange($event)"
        (focus)="onfocus.emit()"
        (blur)="onTouchedCallback()"
        [step]="step"
        [placeholder]="placeholder"
        [readonly]="readonly">

        <div class="error-icon" *ngIf="((ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid) && loginStyle"><i class="las la-exclamation-circle"></i></div>
    </div>
</ng-container>

<div 
[class.login]="loginStyle" 
class="error-block" *ngIf="((ngControl.control.touched || ngControl.control.dirty) && ngControl.control.invalid) && !hideErrorText">
    <p [class.invisible]="loginStyle" 
    *ngIf="ngControl.control.errors?.required">
        <span *ngIf="!loginStyle">Este campo es obligatorio</span>
    </p>

    <p *ngIf="ngControl.control.errors?.email">Correo electrónico inválido</p>

    <p *ngIf="ngControl.control.errors?.minlength">
        El campo debe contener más de {{ngControl.control.errors?.minlength.requiredLength}} caracteres</p>
    <p *ngIf="ngControl.control.errors?.maxlength">
        El campo debe contener menos de {{ngControl.control.errors?.maxlength.requiredLength}} caracteres</p>

    <p *ngIf="ngControl.control.errors?.min">El valor está por debajo del requerido</p>
    <p *ngIf="ngControl.control.errors?.max">El valor está por encima del requerido</p>

    <p *ngIf="ngControl.control.errors?.mismatch">Las contraseñas deben coincidir</p>
</div>
